Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/LDF/ldfslp.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/LDF/ldfslp.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/LDF/ldfslp.F90	(revision 12928)
@@ -489,30 +457,28 @@
       DO jl = 0, 1                            ! calculate slope of the 4 triads immediately ONE level below mixed-layer base
          DO kp = 0, 1                         ! with only the slope-max limit   and   MASKED
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1
-                  ip = jl   ;   jp = jl
-                  !
-                  jk = nmln(ji+ip,jj) + 1
-                  IF( jk > mbkt(ji+ip,jj) ) THEN   ! ML reaches bottom
-                     zti_mlb(ji+ip,jj   ,1-ip,kp) = 0.0_wp
-                  ELSE                             
-                     ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
-                     zti_g_raw = (  zdxrho(ji+ip,jj,jk-kp,1-ip) / zdzrho(ji+ip,jj,jk-kp,kp)      &
-                        &          - ( gdept_n(ji+1,jj,jk-kp) - gdept_n(ji,jj,jk-kp) ) * r1_e1u(ji,jj)  ) * umask(ji,jj,jk)
-                     ze3_e1    =  e3w_n(ji+ip,jj,jk-kp) * r1_e1u(ji,jj) 
-                     zti_mlb(ji+ip,jj   ,1-ip,kp) = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e1  , ABS( zti_g_raw ) ), zti_g_raw )
-                  ENDIF
-                  !
-                  jk = nmln(ji,jj+jp) + 1
-                  IF( jk >  mbkt(ji,jj+jp) ) THEN  !ML reaches bottom
-                     ztj_mlb(ji   ,jj+jp,1-jp,kp) = 0.0_wp
-                  ELSE
-                     ztj_g_raw = (  zdyrho(ji,jj+jp,jk-kp,1-jp) / zdzrho(ji,jj+jp,jk-kp,kp)      &
-                        &      - ( gdept_n(ji,jj+1,jk-kp) - gdept_n(ji,jj,jk-kp) ) / e2v(ji,jj)  ) * vmask(ji,jj,jk)
-                     ze3_e2    =  e3w_n(ji,jj+jp,jk-kp) / e2v(ji,jj)
-                     ztj_mlb(ji   ,jj+jp,1-jp,kp) = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e2  , ABS( ztj_g_raw ) ), ztj_g_raw )
-                  ENDIF
-               END DO
-            END DO
+            DO_2D_10_10
+               ip = jl   ;   jp = jl
+               !
+               jk = nmln(ji+ip,jj) + 1
+               IF( jk > mbkt(ji+ip,jj) ) THEN   ! ML reaches bottom
+                  zti_mlb(ji+ip,jj   ,1-ip,kp) = 0.0_wp
+               ELSE                             
+                  ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
+                  zti_g_raw = (  zdxrho(ji+ip,jj,jk-kp,1-ip) / zdzrho(ji+ip,jj,jk-kp,kp)      &
+                     &          - ( gdept(ji+1,jj,jk-kp,Kmm) - gdept(ji,jj,jk-kp,Kmm) ) * r1_e1u(ji,jj)  ) * umask(ji,jj,jk)
+                  ze3_e1    =  e3w(ji+ip,jj,jk-kp,Kmm) * r1_e1u(ji,jj) 
+                  zti_mlb(ji+ip,jj   ,1-ip,kp) = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e1  , ABS( zti_g_raw ) ), zti_g_raw )
+               ENDIF
+               !
+               jk = nmln(ji,jj+jp) + 1
+               IF( jk >  mbkt(ji,jj+jp) ) THEN  !ML reaches bottom
+                  ztj_mlb(ji   ,jj+jp,1-jp,kp) = 0.0_wp
+               ELSE
+                  ztj_g_raw = (  zdyrho(ji,jj+jp,jk-kp,1-jp) / zdzrho(ji,jj+jp,jk-kp,kp)      &
+                     &      - ( gdept(ji,jj+1,jk-kp,Kmm) - gdept(ji,jj,jk-kp,Kmm) ) / e2v(ji,jj)  ) * vmask(ji,jj,jk)
+                  ze3_e2    =  e3w(ji,jj+jp,jk-kp,Kmm) / e2v(ji,jj)
+                  ztj_mlb(ji   ,jj+jp,1-jp,kp) = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e2  , ABS( ztj_g_raw ) ), ztj_g_raw )
+               ENDIF
+            END_2D
          END DO
       END DO
@@ -528,81 +494,79 @@
                ! Must mask contribution to slope from dz/dx at constant s for triads jk=1,kp=0 that poke up though ocean surface
                znot_thru_surface = REAL( 1-1/(jk+kp), wp )  !jk+kp=1,=0.; otherwise=1.0
-               DO jj = 1, jpjm1
-                  DO ji = 1, fs_jpim1         ! vector opt.
-                     !
-                     ! Calculate slope relative to geopotentials used for GM skew fluxes
-                     ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
-                     ! Limit by slope *relative to geopotentials* by rn_slpmax, and mask by psi-point
-                     ! masked by umask taken at the level of dz(rho)
-                     !
-                     ! raw slopes: unmasked unbounded slopes (relative to geopotential (zti_g) and model surface (zti)
-                     !
-                     zti_raw   = zdxrho(ji+ip,jj   ,jk,1-ip) / zdzrho(ji+ip,jj   ,jk,kp)                   ! unmasked
-                     ztj_raw   = zdyrho(ji   ,jj+jp,jk,1-jp) / zdzrho(ji   ,jj+jp,jk,kp)
-                     !
-                     ! Must mask contribution to slope for triad jk=1,kp=0 that poke up though ocean surface
-                     zti_coord = znot_thru_surface * ( gdept_n(ji+1,jj  ,jk) - gdept_n(ji,jj,jk) ) * r1_e1u(ji,jj)
-                     ztj_coord = znot_thru_surface * ( gdept_n(ji  ,jj+1,jk) - gdept_n(ji,jj,jk) ) * r1_e2v(ji,jj)     ! unmasked
-                     zti_g_raw = zti_raw - zti_coord      ! ref to geopot surfaces
-                     ztj_g_raw = ztj_raw - ztj_coord
-                     ! additional limit required in bilaplacian case
-                     ze3_e1    = e3w_n(ji+ip,jj   ,jk+kp) * r1_e1u(ji,jj)
-                     ze3_e2    = e3w_n(ji   ,jj+jp,jk+kp) * r1_e2v(ji,jj)
-                     ! NB: hard coded factor 5 (can be a namelist parameter...)
-                     zti_g_lim = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e1, ABS( zti_g_raw ) ), zti_g_raw )
-                     ztj_g_lim = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e2, ABS( ztj_g_raw ) ), ztj_g_raw )
-                     !
-                     ! Below  ML use limited zti_g as is & mask
-                     ! Inside ML replace by linearly reducing sx_mlb towards surface & mask
-                     !
-                     zfacti = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji+ip,jj)), wp )  ! k index of uppermost point(s) of triad is jk+kp-1
-                     zfactj = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji,jj+jp)), wp )  ! must be .ge. nmln(ji,jj) for zfact=1
-                     !                                                          !                   otherwise  zfact=0
-                     zti_g_lim =          ( zfacti   * zti_g_lim                       &
-                        &      + ( 1._wp - zfacti ) * zti_mlb(ji+ip,jj,1-ip,kp)   &
-                        &                           * gdepw_n(ji+ip,jj,jk+kp) * z1_mlbw(ji+ip,jj) ) * umask(ji,jj,jk+kp)
-                     ztj_g_lim =          ( zfactj   * ztj_g_lim                       &
-                        &      + ( 1._wp - zfactj ) * ztj_mlb(ji,jj+jp,1-jp,kp)   &
-                        &                           * gdepw_n(ji,jj+jp,jk+kp) * z1_mlbw(ji,jj+jp) ) * vmask(ji,jj,jk+kp)
-                     !
-                     triadi_g(ji+ip,jj   ,jk,1-ip,kp) = zti_g_lim
-                     triadj_g(ji   ,jj+jp,jk,1-jp,kp) = ztj_g_lim
-                     !
-                     ! Get coefficients of isoneutral diffusion tensor
-                     ! 1. Utilise gradients *relative* to s-coordinate, so add t-point slopes (*subtract* depth gradients)
-                     ! 2. We require that isoneutral diffusion  gives no vertical buoyancy flux
-                     !     i.e. 33 term = (real slope* 31, 13 terms)
-                     ! To do this, retain limited sx**2  in vertical flux, but divide by real slope for 13/31 terms
-                     ! Equivalent to tapering A_iso = sx_limited**2/(real slope)**2
-                     !
-                     zti_lim  = ( zti_g_lim + zti_coord ) * umask(ji,jj,jk+kp)    ! remove coordinate slope => relative to coordinate surfaces
-                     ztj_lim  = ( ztj_g_lim + ztj_coord ) * vmask(ji,jj,jk+kp)
-                     !
-                     IF( ln_triad_iso ) THEN
-                        zti_raw = zti_lim*zti_lim / zti_raw
-                        ztj_raw = ztj_lim*ztj_lim / ztj_raw
-                        zti_raw = SIGN( MIN( ABS(zti_lim), ABS( zti_raw ) ), zti_raw )
-                        ztj_raw = SIGN( MIN( ABS(ztj_lim), ABS( ztj_raw ) ), ztj_raw )
-                        zti_lim = zfacti * zti_lim + ( 1._wp - zfacti ) * zti_raw
-                        ztj_lim = zfactj * ztj_lim + ( 1._wp - zfactj ) * ztj_raw
-                     ENDIF
-                     !                                      ! switching triad scheme 
-                     zisw = (1._wp - rn_sw_triad ) + rn_sw_triad    &
-                        &            * 2._wp * ABS( 0.5_wp - kp - ( 0.5_wp - ip ) * SIGN( 1._wp , zdxrho(ji+ip,jj,jk,1-ip) )  )
-                     zjsw = (1._wp - rn_sw_triad ) + rn_sw_triad    &
-                        &            * 2._wp * ABS( 0.5_wp - kp - ( 0.5_wp - jp ) * SIGN( 1._wp , zdyrho(ji,jj+jp,jk,1-jp) )  )
-                     !
-                     triadi(ji+ip,jj   ,jk,1-ip,kp) = zti_lim * zisw
-                     triadj(ji   ,jj+jp,jk,1-jp,kp) = ztj_lim * zjsw
-                     !
-                     zbu  = e1e2u(ji   ,jj   ) * e3u_n(ji   ,jj   ,jk   )
-                     zbv  = e1e2v(ji   ,jj   ) * e3v_n(ji   ,jj   ,jk   )
-                     zbti = e1e2t(ji+ip,jj   ) * e3w_n(ji+ip,jj   ,jk+kp)
-                     zbtj = e1e2t(ji   ,jj+jp) * e3w_n(ji   ,jj+jp,jk+kp)
-                     !
-                     wslp2(ji+ip,jj,jk+kp) = wslp2(ji+ip,jj,jk+kp) + 0.25_wp * zbu / zbti * zti_g_lim*zti_g_lim      ! masked
-                     wslp2(ji,jj+jp,jk+kp) = wslp2(ji,jj+jp,jk+kp) + 0.25_wp * zbv / zbtj * ztj_g_lim*ztj_g_lim
-                  END DO
-               END DO
+               DO_2D_10_10
+                  !
+                  ! Calculate slope relative to geopotentials used for GM skew fluxes
+                  ! Add s-coordinate slope at t-points (do this by *subtracting* gradient of depth)
+                  ! Limit by slope *relative to geopotentials* by rn_slpmax, and mask by psi-point
+                  ! masked by umask taken at the level of dz(rho)
+                  !
+                  ! raw slopes: unmasked unbounded slopes (relative to geopotential (zti_g) and model surface (zti)
+                  !
+                  zti_raw   = zdxrho(ji+ip,jj   ,jk,1-ip) / zdzrho(ji+ip,jj   ,jk,kp)                   ! unmasked
+                  ztj_raw   = zdyrho(ji   ,jj+jp,jk,1-jp) / zdzrho(ji   ,jj+jp,jk,kp)
+                  !
+                  ! Must mask contribution to slope for triad jk=1,kp=0 that poke up though ocean surface
+                  zti_coord = znot_thru_surface * ( gdept(ji+1,jj  ,jk,Kmm) - gdept(ji,jj,jk,Kmm) ) * r1_e1u(ji,jj)
+                  ztj_coord = znot_thru_surface * ( gdept(ji  ,jj+1,jk,Kmm) - gdept(ji,jj,jk,Kmm) ) * r1_e2v(ji,jj)     ! unmasked
+                  zti_g_raw = zti_raw - zti_coord      ! ref to geopot surfaces
+                  ztj_g_raw = ztj_raw - ztj_coord
+                  ! additional limit required in bilaplacian case
+                  ze3_e1    = e3w(ji+ip,jj   ,jk+kp,Kmm) * r1_e1u(ji,jj)
+                  ze3_e2    = e3w(ji   ,jj+jp,jk+kp,Kmm) * r1_e2v(ji,jj)
+                  ! NB: hard coded factor 5 (can be a namelist parameter...)
+                  zti_g_lim = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e1, ABS( zti_g_raw ) ), zti_g_raw )
+                  ztj_g_lim = SIGN( MIN( rn_slpmax, 5.0_wp * ze3_e2, ABS( ztj_g_raw ) ), ztj_g_raw )
+                  !
+                  ! Below  ML use limited zti_g as is & mask
+                  ! Inside ML replace by linearly reducing sx_mlb towards surface & mask
+                  !
+                  zfacti = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji+ip,jj)), wp )  ! k index of uppermost point(s) of triad is jk+kp-1
+                  zfactj = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji,jj+jp)), wp )  ! must be .ge. nmln(ji,jj) for zfact=1
+                  !                                                          !                   otherwise  zfact=0
+                  zti_g_lim =          ( zfacti   * zti_g_lim                       &
+                     &      + ( 1._wp - zfacti ) * zti_mlb(ji+ip,jj,1-ip,kp)   &
+                     &                           * gdepw(ji+ip,jj,jk+kp,Kmm) * z1_mlbw(ji+ip,jj) ) * umask(ji,jj,jk+kp)
+                  ztj_g_lim =          ( zfactj   * ztj_g_lim                       &
+                     &      + ( 1._wp - zfactj ) * ztj_mlb(ji,jj+jp,1-jp,kp)   &
+                     &                           * gdepw(ji,jj+jp,jk+kp,Kmm) * z1_mlbw(ji,jj+jp) ) * vmask(ji,jj,jk+kp)
+                  !
+                  triadi_g(ji+ip,jj   ,jk,1-ip,kp) = zti_g_lim
+                  triadj_g(ji   ,jj+jp,jk,1-jp,kp) = ztj_g_lim
+                  !
+                  ! Get coefficients of isoneutral diffusion tensor
+                  ! 1. Utilise gradients *relative* to s-coordinate, so add t-point slopes (*subtract* depth gradients)
+                  ! 2. We require that isoneutral diffusion  gives no vertical buoyancy flux
+                  !     i.e. 33 term = (real slope* 31, 13 terms)
+                  ! To do this, retain limited sx**2  in vertical flux, but divide by real slope for 13/31 terms
+                  ! Equivalent to tapering A_iso = sx_limited**2/(real slope)**2
+                  !
+                  zti_lim  = ( zti_g_lim + zti_coord ) * umask(ji,jj,jk+kp)    ! remove coordinate slope => relative to coordinate surfaces
+                  ztj_lim  = ( ztj_g_lim + ztj_coord ) * vmask(ji,jj,jk+kp)
+                  !
+                  IF( ln_triad_iso ) THEN
+                     zti_raw = zti_lim*zti_lim / zti_raw
+                     ztj_raw = ztj_lim*ztj_lim / ztj_raw
+                     zti_raw = SIGN( MIN( ABS(zti_lim), ABS( zti_raw ) ), zti_raw )
+                     ztj_raw = SIGN( MIN( ABS(ztj_lim), ABS( ztj_raw ) ), ztj_raw )
+                     zti_lim = zfacti * zti_lim + ( 1._wp - zfacti ) * zti_raw
+                     ztj_lim = zfactj * ztj_lim + ( 1._wp - zfactj ) * ztj_raw
+                  ENDIF
+                  !                                      ! switching triad scheme 
+                  zisw = (1._wp - rn_sw_triad ) + rn_sw_triad    &
+                     &            * 2._wp * ABS( 0.5_wp - kp - ( 0.5_wp - ip ) * SIGN( 1._wp , zdxrho(ji+ip,jj,jk,1-ip) )  )
+                  zjsw = (1._wp - rn_sw_triad ) + rn_sw_triad    &
+                     &            * 2._wp * ABS( 0.5_wp - kp - ( 0.5_wp - jp ) * SIGN( 1._wp , zdyrho(ji,jj+jp,jk,1-jp) )  )
+                  !
+                  triadi(ji+ip,jj   ,jk,1-ip,kp) = zti_lim * zisw
+                  triadj(ji   ,jj+jp,jk,1-jp,kp) = ztj_lim * zjsw
+                  !
+                  zbu  = e1e2u(ji   ,jj   ) * e3u(ji   ,jj   ,jk   ,Kmm)
+                  zbv  = e1e2v(ji   ,jj   ) * e3v(ji   ,jj   ,jk   ,Kmm)
+                  zbti = e1e2t(ji+ip,jj   ) * e3w(ji+ip,jj   ,jk+kp,Kmm)
+                  zbtj = e1e2t(ji   ,jj+jp) * e3w(ji   ,jj+jp,jk+kp,Kmm)
+                  !
+                  wslp2(ji+ip,jj,jk+kp) = wslp2(ji+ip,jj,jk+kp) + 0.25_wp * zbu / zbti * zti_g_lim*zti_g_lim      ! masked
+                  wslp2(ji,jj+jp,jk+kp) = wslp2(ji,jj+jp,jk+kp) + 0.25_wp * zbv / zbtj * ztj_g_lim*ztj_g_lim
+               END_2D
             END DO
          END DO
@@ -618,5 +582,5 @@
 
 
-   SUBROUTINE ldf_slp_mxl( prd, pn2, p_gru, p_grv, p_dzr )
+   SUBROUTINE ldf_slp_mxl( prd, pn2, p_gru, p_grv, p_dzr, Kmm )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE ldf_slp_mxl  ***
@@ -638,4 +602,5 @@
       REAL(wp), DIMENSION(:,:,:), INTENT(in) ::   p_gru, p_grv   ! i- & j-gradient of density (u- & v-pts)
       REAL(wp), DIMENSION(:,:,:), INTENT(in) ::   p_dzr          ! z-gradient of density      (T-point)
+      INTEGER , INTENT(in)                   ::   Kmm            ! ocean time level indices
       !!
       INTEGER  ::   ji , jj , jk                   ! dummy loop indices
@@ -658,14 +623,10 @@
       !
       !                                            !==   surface mixed layer mask   !
-      DO jk = 1, jpk                               ! =1 inside the mixed layer, =0 otherwise
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ik = nmln(ji,jj) - 1
-               IF( jk <= ik ) THEN   ;   omlmask(ji,jj,jk) = 1._wp
-               ELSE                  ;   omlmask(ji,jj,jk) = 0._wp
-               ENDIF
-            END DO
-         END DO
-      END DO
+      DO_3D_11_11( 1, jpk )
+         ik = nmln(ji,jj) - 1
+         IF( jk <= ik ) THEN   ;   omlmask(ji,jj,jk) = 1._wp
+         ELSE                  ;   omlmask(ji,jj,jk) = 0._wp
+         ENDIF
+      END_3D
 
 
@@ -680,48 +641,46 @@
       !-----------------------------------------------------------------------
       !
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            !                        !==   Slope at u- & v-points just below the Mixed Layer   ==!
-            !
-            !                        !- vertical density gradient for u- and v-slopes (from dzr at T-point)
-            iku = MIN(  MAX( 1, nmln(ji,jj) , nmln(ji+1,jj) ) , jpkm1  )   ! ML (MAX of T-pts, bound by jpkm1)
-            ikv = MIN(  MAX( 1, nmln(ji,jj) , nmln(ji,jj+1) ) , jpkm1  )   !
-            zbu = 0.5_wp * ( p_dzr(ji,jj,iku) + p_dzr(ji+1,jj  ,iku) )
-            zbv = 0.5_wp * ( p_dzr(ji,jj,ikv) + p_dzr(ji  ,jj+1,ikv) )
-            !                        !- horizontal density gradient at u- & v-points
-            zau = p_gru(ji,jj,iku) * r1_e1u(ji,jj)
-            zav = p_grv(ji,jj,ikv) * r1_e2v(ji,jj)
-            !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0
-            !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-            zbu = MIN(  zbu , - z1_slpmax * ABS( zau ) , -7.e+3_wp/e3u_n(ji,jj,iku)* ABS( zau )  )
-            zbv = MIN(  zbv , - z1_slpmax * ABS( zav ) , -7.e+3_wp/e3v_n(ji,jj,ikv)* ABS( zav )  )
-            !                        !- Slope at u- & v-points (uslpml, vslpml)
-            uslpml(ji,jj) = zau / ( zbu - zeps ) * umask(ji,jj,iku)
-            vslpml(ji,jj) = zav / ( zbv - zeps ) * vmask(ji,jj,ikv)
-            !
-            !                        !==   i- & j-slopes at w-points just below the Mixed Layer   ==!
-            !
-            ik   = MIN( nmln(ji,jj) + 1, jpk )
-            ikm1 = MAX( 1, ik-1 )
-            !                        !- vertical density gradient for w-slope (from N^2)
-            zbw = zm1_2g * pn2 (ji,jj,ik) * ( prd (ji,jj,ik) + prd (ji,jj,ikm1) + 2. )
-            !                        !- horizontal density i- & j-gradient at w-points
-            zci = MAX(   umask(ji-1,jj,ik  ) + umask(ji,jj,ik  )           &
-               &       + umask(ji-1,jj,ikm1) + umask(ji,jj,ikm1) , zeps  ) * e1t(ji,jj)
-            zcj = MAX(   vmask(ji,jj-1,ik  ) + vmask(ji,jj,ik  )           &
-               &       + vmask(ji,jj-1,ikm1) + vmask(ji,jj,ikm1) , zeps  ) * e2t(ji,jj)
-            zai =    (   p_gru(ji-1,jj,ik  ) + p_gru(ji,jj,ik)             &
-               &       + p_gru(ji-1,jj,ikm1) + p_gru(ji,jj,ikm1  )  ) / zci  * tmask(ji,jj,ik)
-            zaj =    (   p_grv(ji,jj-1,ik  ) + p_grv(ji,jj,ik  )           &
-               &       + p_grv(ji,jj-1,ikm1) + p_grv(ji,jj,ikm1)  ) / zcj  * tmask(ji,jj,ik)
-            !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0.
-            !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
-            zbi = MIN(  zbw , -100._wp* ABS( zai ) , -7.e+3_wp/e3w_n(ji,jj,ik)* ABS( zai )  )
-            zbj = MIN(  zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/e3w_n(ji,jj,ik)* ABS( zaj )  )
-            !                        !- i- & j-slope at w-points (wslpiml, wslpjml)
-            wslpiml(ji,jj) = zai / ( zbi - zeps ) * tmask (ji,jj,ik)
-            wslpjml(ji,jj) = zaj / ( zbj - zeps ) * tmask (ji,jj,ik)
-         END DO
-      END DO
+      DO_2D_00_00
+         !                        !==   Slope at u- & v-points just below the Mixed Layer   ==!
+         !
+         !                        !- vertical density gradient for u- and v-slopes (from dzr at T-point)
+         iku = MIN(  MAX( 1, nmln(ji,jj) , nmln(ji+1,jj) ) , jpkm1  )   ! ML (MAX of T-pts, bound by jpkm1)
+         ikv = MIN(  MAX( 1, nmln(ji,jj) , nmln(ji,jj+1) ) , jpkm1  )   !
+         zbu = 0.5_wp * ( p_dzr(ji,jj,iku) + p_dzr(ji+1,jj  ,iku) )
+         zbv = 0.5_wp * ( p_dzr(ji,jj,ikv) + p_dzr(ji  ,jj+1,ikv) )
+         !                        !- horizontal density gradient at u- & v-points
+         zau = p_gru(ji,jj,iku) * r1_e1u(ji,jj)
+         zav = p_grv(ji,jj,ikv) * r1_e2v(ji,jj)
+         !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0
+         !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
+         zbu = MIN(  zbu , - z1_slpmax * ABS( zau ) , -7.e+3_wp/e3u(ji,jj,iku,Kmm)* ABS( zau )  )
+         zbv = MIN(  zbv , - z1_slpmax * ABS( zav ) , -7.e+3_wp/e3v(ji,jj,ikv,Kmm)* ABS( zav )  )
+         !                        !- Slope at u- & v-points (uslpml, vslpml)
+         uslpml(ji,jj) = zau / ( zbu - zeps ) * umask(ji,jj,iku)
+         vslpml(ji,jj) = zav / ( zbv - zeps ) * vmask(ji,jj,ikv)
+         !
+         !                        !==   i- & j-slopes at w-points just below the Mixed Layer   ==!
+         !
+         ik   = MIN( nmln(ji,jj) + 1, jpk )
+         ikm1 = MAX( 1, ik-1 )
+         !                        !- vertical density gradient for w-slope (from N^2)
+         zbw = zm1_2g * pn2 (ji,jj,ik) * ( prd (ji,jj,ik) + prd (ji,jj,ikm1) + 2. )
+         !                        !- horizontal density i- & j-gradient at w-points
+         zci = MAX(   umask(ji-1,jj,ik  ) + umask(ji,jj,ik  )           &
+            &       + umask(ji-1,jj,ikm1) + umask(ji,jj,ikm1) , zeps  ) * e1t(ji,jj)
+         zcj = MAX(   vmask(ji,jj-1,ik  ) + vmask(ji,jj,ik  )           &
+            &       + vmask(ji,jj-1,ikm1) + vmask(ji,jj,ikm1) , zeps  ) * e2t(ji,jj)
+         zai =    (   p_gru(ji-1,jj,ik  ) + p_gru(ji,jj,ik)             &
+            &       + p_gru(ji-1,jj,ikm1) + p_gru(ji,jj,ikm1  )  ) / zci  * tmask(ji,jj,ik)
+         zaj =    (   p_grv(ji,jj-1,ik  ) + p_grv(ji,jj,ik  )           &
+            &       + p_grv(ji,jj-1,ikm1) + p_grv(ji,jj,ikm1)  ) / zcj  * tmask(ji,jj,ik)
+         !                        !- bound the slopes: abs(zw.)<= 1/100 and zb..<0.
+         !                           kxz max= ah slope max =< e1 e3 /(pi**2 2 dt)
+         zbi = MIN(  zbw , -100._wp* ABS( zai ) , -7.e+3_wp/e3w(ji,jj,ik,Kmm)* ABS( zai )  )
+         zbj = MIN(  zbw , -100._wp* ABS( zaj ) , -7.e+3_wp/e3w(ji,jj,ik,Kmm)* ABS( zaj )  )
+         !                        !- i- & j-slope at w-points (wslpiml, wslpjml)
+         wslpiml(ji,jj) = zai / ( zbi - zeps ) * tmask (ji,jj,ik)
+         wslpjml(ji,jj) = zaj / ( zbj - zeps ) * tmask (ji,jj,ik)
+      END_2D
       !!gm this lbc_lnk should be useless....
       CALL lbc_lnk_multi( 'ldfslp', uslpml , 'U', -1. , vslpml , 'V', -1. , wslpiml, 'W', -1. , wslpjml, 'W', -1. ) 
@@ -785,9 +744,9 @@
 !            DO jk = 1, jpk
 !               DO jj = 2, jpjm1
-!                  DO ji = fs_2, fs_jpim1   ! vector opt.
-!                     uslp (ji,jj,jk) = - ( gdept_n(ji+1,jj,jk) - gdept_n(ji ,jj ,jk) ) * r1_e1u(ji,jj) * umask(ji,jj,jk)
-!                     vslp (ji,jj,jk) = - ( gdept_n(ji,jj+1,jk) - gdept_n(ji ,jj ,jk) ) * r1_e2v(ji,jj) * vmask(ji,jj,jk)
-!                     wslpi(ji,jj,jk) = - ( gdepw_n(ji+1,jj,jk) - gdepw_n(ji-1,jj,jk) ) * r1_e1t(ji,jj) * wmask(ji,jj,jk) * 0.5
-!                     wslpj(ji,jj,jk) = - ( gdepw_n(ji,jj+1,jk) - gdepw_n(ji,jj-1,jk) ) * r1_e2t(ji,jj) * wmask(ji,jj,jk) * 0.5
+!                  DO ji = 2, jpim1   ! vector opt.
+!                     uslp (ji,jj,jk) = - ( gdept(ji+1,jj,jk,Kmm) - gdept(ji ,jj ,jk,Kmm) ) * r1_e1u(ji,jj) * umask(ji,jj,jk)
+!                     vslp (ji,jj,jk) = - ( gdept(ji,jj+1,jk,Kmm) - gdept(ji ,jj ,jk,Kmm) ) * r1_e2v(ji,jj) * vmask(ji,jj,jk)
+!                     wslpi(ji,jj,jk) = - ( gdepw(ji+1,jj,jk,Kmm) - gdepw(ji-1,jj,jk,Kmm) ) * r1_e1t(ji,jj) * wmask(ji,jj,jk) * 0.5
+!                     wslpj(ji,jj,jk) = - ( gdepw(ji,jj+1,jk,Kmm) - gdepw(ji,jj-1,jk,Kmm) ) * r1_e2t(ji,jj) * wmask(ji,jj,jk) * 0.5
 !                  END DO
 !               END DO
